diff -ur -x .* -x*.o -x zImage* -x vmlinu* linuxppc_2_4_devel/drivers/pci/pci.c linuxppc_2_4_devel-140/drivers/pci/pci.c
--- linuxppc_2_4_devel/drivers/pci/pci.c	Sat Sep 22 17:42:06 2001
+++ linuxppc_2_4_devel-140/drivers/pci/pci.c	Sat Sep 22 19:39:14 2001
@@ -975,6 +975,7 @@
 		res->start = base;
 		res->end = limit + 0xfff;
 		res->name = child->name;
+#ifndef __powerpc
 	} else {
 		/*
 		 * Ugh. We don't know enough about this bridge. Just assume
@@ -983,6 +984,27 @@
 		printk(KERN_ERR "Unknown bridge resource %d: assuming transparent\n", 0);
 		child->resource[0] = child->parent->resource[0];
 	}
+#else /* __powerpc__ */
+	/*
+	 * hack for now
+	 * -olh
+	 */
+	} else {
+		if (base > limit) {
+			if(_machine == _MACH_prep) {
+				/*
+				 * Disabled bridge windows get no resources
+				 * but only on PReP, it could break Pmac
+				 * with Adaptec cards
+				 */
+				printk(KERN_DEBUG "PCI-prep: Found disabled bridge I/O window\n");
+			} else {
+				printk(KERN_ERR "PCI-non-prep: Unknown bridge resource %d: assuming transparent\n", 0);
+				child->resource[0] = child->parent->resource[0];
+			}
+		}
+	}
+#endif
 
 	res = child->resource[1];
 	pci_read_config_word(dev, PCI_MEMORY_BASE, &mem_base_lo);
@@ -994,11 +1016,33 @@
 		res->start = base;
 		res->end = limit + 0xfffff;
 		res->name = child->name;
+#ifndef __powerpc
 	} else {
 		/* See comment above. Same thing */
 		printk(KERN_ERR "Unknown bridge resource %d: assuming transparent\n", 1);
 		child->resource[1] = child->parent->resource[1];
 	}
+#else /* __powerpc__ */
+	/*
+	 * hack for now
+	 * -olh
+	 */
+	} else {
+		if (base > limit) {
+			if(_machine == _MACH_prep) {
+				/*
+				 * Disabled bridge windows get no resources
+				 * but only on PReP, it could break Pmac
+				 * with Adaptec cards
+				 */
+				printk(KERN_DEBUG "PCI-prep: Found disabled bridge memory window\n");
+			} else {
+				printk(KERN_ERR "PCI-non-prep: Unknown bridge resource %d: assuming transparent\n", 1);
+				child->resource[1] = child->parent->resource[1];
+			}
+		}
+	}
+#endif
 
 	res = child->resource[2];
 	pci_read_config_word(dev, PCI_PREF_MEMORY_BASE, &mem_base_lo);
@@ -1025,11 +1069,33 @@
 		res->start = base;
 		res->end = limit + 0xfffff;
 		res->name = child->name;
+#ifndef __powerpc__
 	} else {
 		/* See comments above */
 		printk(KERN_ERR "Unknown bridge resource %d: assuming transparent\n", 2);
 		child->resource[2] = child->parent->resource[2];
 	}
+#else /* __powerpc__ */
+	/*
+	 * hack for now
+	 * -olh
+	 */
+	} else {
+		if (base > limit) {
+			if(_machine == _MACH_prep) {
+				/*
+				 * Disabled bridge windows get no resources
+				 * but only on PReP, it could break Pmac
+				 * with Adaptec cards
+				 */
+				printk(KERN_DEBUG "PCI-prep: Found disabled bridge prefetch window\n");
+			} else {
+				printk(KERN_ERR "PCI-non-prep: Unknown bridge resource %d: assuming transparent\n", 2);
+				child->resource[2] = child->parent->resource[2];
+			}
+		}
+	}
+#endif
 }
 
 static struct pci_bus * __init pci_alloc_bus(void)
